clear all;clc;
% close all
DataC=load('L2Caverage.txt');
Au=[185,158,158,0,0,0,158,185,158,0,0,0,158,158,185,0,0,0,0,0,0,39.7,0,0,0,0,0,0,39.7,0,0,0,0,0,0,39.7];

for steps = [740]
    Au = DataC(steps,:);
    N = 50;
    thetavec = linspace(0,pi,N);
    phivec = linspace(0,2*pi,2*N);
    [th, ph] = meshgrid(thetavec,phivec);
   
    C_Voigt(1,:)=Au(1:6);
    C_Voigt(2,:)=Au(7:12);
    C_Voigt(3,:)=Au(13:18);
    C_Voigt(4,:)=Au(19:24);
    C_Voigt(5,:)=Au(25:30);
    C_Voigt(6,:)=Au(31:36);
    
    C_Voigt_new = zeros(6,6);
    %% Use B matrix
    for i = 1:3
        for j = 1:3
            for k = 1:3
                for l = 1:3
                    p = i *double(eq(i,j))+ (1-double(eq(i,j)))*(9-i-j);
                    q = k *double(eq(k,l))+ (1-double(eq(k,l)))*(9-k-l);
                    C_Voigt_new(p,q)=C_Voigt_new(p,q)+C_Voigt(p,q);
                end
            end
        end
    end
    
    S_Voigt_new = inv(C_Voigt_new);
    
    E_dir = 0;
    for it1 = 1:N
        for it2 =1:2*N
            compliance =0;
            d = [sin(thetavec(it1))*cos(phivec(it2)),sin(thetavec(it1))*sin(phivec(it2)),cos(thetavec(it1))];
            H = sin(thetavec(it1))*cos(phivec(it2));
            K = sin(thetavec(it1))*sin(phivec(it2));
            L = cos(thetavec(it1));
            for i = 1:3
                for j = 1:3
                    for k = 1:3
                        for l = 1:3
                            p = i *double(eq(i,j))+ (1-double(eq(i,j)))*(9-i-j);
                            q = k *double(eq(k,l))+ (1-double(eq(k,l)))*(9-k-l);
                            compliance = compliance+d(i)*d(j)*d(k)*d(l)*S_Voigt_new(p,q);
                        end
                    end
                end
            end
            E_dir(it2,it1) = 1/compliance;
          
        end
    end
    
    
    x = E_dir.*sin(th).*cos(ph);
    y = E_dir.*sin(th).*sin(ph);
    z = E_dir.*cos(th);
    
   
    
    figure(15);
    surf(x,y,z,E_dir);
    axis equal
    light; lightangle(260,-45) % add 2 lights
    lightangle(60,-45)
    lightangle(10,45)
    lighting gouraud % preferred lighting for a curved surface
    colormap(viridis())
    axis vis3d    
    xlabel('e_1');ylabel('e_2');zlabel('e_3');
end
