#define EIGEN_DONT_ALIGN_STATICALLY
#include <Array.h>
#include "fftw++.h"
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctime>
#include <iostream>
#include <stack>
#include <fstream>
#include <sstream>
#include <chrono>
#include <fenv.h>
#include <time.h>
using namespace std; using namespace Array;using namespace fftwpp;using namespace Eigen;
const unsigned int n=128, nx=n, ny=n, nz=n; const size_t align=sizeof(Complex);

typedef array<double, 3> Displacements;
typedef array3<Complex> Comp;
typedef vector<Comp> FourierDisplacement;
typedef Comp FourierPotential;
typedef array1<Complex> FourierWave;
typedef vector<Displacements> GlobalDisplacements;
typedef vector<double> GlobalPotential;
typedef array2<Complex> Comp2;
typedef vector<Comp> FourierStrain;

double computeB(double Phi) {
	double B = 1./4. *  Phi*Phi * (1.-Phi)*(1.-Phi);
	return B;
}

double computeBp(double Phi) {
	double Bp = 1./2. * Phi * (2. *Phi * Phi - 3. * Phi +1.);
	return Bp;
}

double computeBpp(double Phi) {
	double Bpp =3. * Phi * Phi -3.*Phi + 1./2. ;
	return Bpp;
}


int main()
{ 	// Tools for floating point exception & threading
	//feenableexcept(FE_INVALID | FE_OVERFLOW);
	const int threadnumber=48;
	omp_set_num_threads(threadnumber);

	fftw::maxthreads=threadnumber;

	size_t align=sizeof(Complex);
	char filename[] = "./ResultAtTime_0000000L0.csv";
	char filename_tot[] = "./3dGlobal.txt";

	ofstream outputFile_tot;

	complex<double> Imagine(0,1);
	Comp Ftest;
	Ftest.Allocate(nx,ny,nz,align);
	fft3d Forward3(-1,Ftest);  fft3d Backward3(1,Ftest);
	srand (time(NULL));

	//Initialize global fields
	GlobalPotential phiGlobal(nx*ny*nz);
	GlobalPotential kappaGlobal(nx*ny*nz);
	GlobalPotential muGlobal(nx*ny*nz);
	GlobalPotential gammaGlobal(nx*ny*nz);
	GlobalPotential rGlobal(nx*ny*nz);
	GlobalPotential pGlobal(nx*ny*nz);
	GlobalPotential lkappaGlobal(nx*ny*nz);
	GlobalPotential divMGlobal(nx*ny*nz);
	GlobalPotential lphiGlobal(nx*ny*nz);


	GlobalDisplacements gradPhiGlobal(nx*ny*nz);
	GlobalDisplacements uGlobal(nx*ny*nz);
	GlobalDisplacements qGlobal(nx*ny*nz);
	GlobalDisplacements gradmuGlobal(nx*ny*nz);
	GlobalDisplacements mGlobal(nx*ny*nz);

	FourierPotential Fmu,Fphi,Fkappa,Fgamma,Fr,Fp,Flkappa,FdivM,Flphi;
	FourierDisplacement Fq(3),Fgradphi(3),Fu(3),Fm(3),Fgradmu(3);

	Fmu.Allocate(nx,ny,nz,align);Fphi.Allocate(nx,ny,nz,align);Fkappa.Allocate(nx,ny,nz,align);Fgamma.Allocate(nx,ny,nz, align);Fr.Allocate(nx,ny,nz,align);
	Fp.Allocate(nx,ny,nz,align);Flkappa.Allocate(nx,ny,nz,align);FdivM.Allocate(nx,ny,nz,align);Flphi.Allocate(nx,ny,nz,align);

	for(unsigned int i=0;i<3;i++){
		Fq[i].Allocate(nx,ny,nz,align);
		Fgradphi[i].Allocate(nx,ny,nz,align);
		Fu[i].Allocate(nx,ny,nz,align);
		Fm[i].Allocate(nx,ny,nz,align);
		Fgradmu[i].Allocate(nx,ny,nz,align);
	}
	for(unsigned int i=0;i<9;i++){
		Fep[i].Allocate(nx,ny,nz,align);Ftau[i].Allocate(nx,ny,nz,align);ts[i].Allocate(nx,ny,nz,align);}



	FourierWave Kvec2x,Kvec2y,Kvec2z;
	FourierWave Kvecx,Kvecy,Kvecz;

	double pi = 3.14159265359;
	double Lex=6.4;	double hx=2.*pi/Lex;	double delx=Lex/(1.*nx);
	double Ley=6.4;	double hy=2.*pi/Ley;	double dely=Ley/(1.*ny);
	double Lez=6.4;	double hz=2.*pi/Lez;	double delz=Lez/(1.*nz);


	array<double,nx> Kx;
	array<double,ny> Ky;
	array<double,nz> Kz;
	Kvec2x.Allocate(nx,align);
	Kvec2y.Allocate(ny,align);
	Kvec2z.Allocate(nz,align);
	Kvecx.Allocate(nx,align);
	Kvecy.Allocate(ny,align);
	Kvecz.Allocate(nz,align);


	for (unsigned int i=0;i<nx/2+1;i++){
		Kx[i]=i*1.; Kvec2x[i] = complex<double> (0.,0.);
	}
	for (unsigned int i=1;i<nx/2;i++){
		Kx[i+nx/2]=(i-nx/2.)*1.; Kvec2x[i+nx/2] = complex<double> (0.,0.);
	}

	for (unsigned int i=0;i<ny/2+1;i++){
		Ky[i]=i*1.; Kvec2y[i] =complex<double>  (0.,0.);
	}
	for (unsigned int i=1;i<ny/2;i++){
		Ky[i+ny/2]=(i-ny/2.)*1.; Kvec2y[i+ny/2] =complex<double> (0.,0.);
	}

	for (unsigned int i=0;i<nz/2+1;i++){
		Kz[i]=i*1.; Kvec2z[i] =complex<double>  (0.,0.);
	}
	for (unsigned int i=1;i<nz/2;i++){
		Kz[i+nz/2]=(i-nz/2.)*1.; Kvec2z[i+nz/2] =complex<double> (0.,0.);
	}

	for (unsigned int i=0;i<nx;i++){
		Kvec2x[i]=Imagine*(8.*sin(hx*delx*Kx[i])/(6.*delx)-sin(2.*hx*delx*Kx[i])/(6.*delx));
		Kvecx[i]=Imagine*hx*Kx[i];
	//	Kvec2x[i]=Imagine*sin(hx*delx*Kx[i])/delx;
	}

	for (unsigned int i=0;i<ny;i++){
		Kvec2y[i]=Imagine*(8.*sin(hy*dely*Ky[i])/(6.*dely)-sin(2.*hy*dely*Ky[i])/(6.*dely));
		Kvecy[i]=Imagine*hy*Ky[i];
	//	Kvec2y[i]=Imagine*sin(hy*dely*Ky[i])/dely;
	}

	for (unsigned int i=0;i<nz;i++){
		Kvec2z[i]=Imagine*(8.*sin(hz*delz*Kz[i])/(6.*delz)-sin(2.*hz*delz*Kz[i])/(6.*delz));
		Kvecz[i]=Imagine*hz*Kz[i];
	//	Kvec2z[i]=Imagine*sin(hz*delz*Kz[i])/delz;
	}


	vector<array<unsigned int,3>> mapper(nx*ny*nz);
	for(unsigned int k=0; k < nz; k++) {
		for(unsigned int j=0; j < ny; j++){
			for(unsigned int i=0; i < nx; i++){
				mapper[k*nx*ny+j*nx+i][0]=i;
				mapper[k*nx*ny+j*nx+i][1]=j;
				mapper[k*nx*ny+j*nx+i][2]=k;
			}
		}
	}
	vector<array<unsigned int,2>> smallmapper(9);
	for(unsigned int k=0; k < 3; k++) {
		for(unsigned int j=0; j < 3; j++){
			smallmapper[k*3+j][0]=k;
			smallmapper[k*3+j][1]=j;
		}
	}

	// Gamma preferred directions
	const int numberofm=2;
	array<array<double,3>,numberofm> marray;

	marray[0][0]=0.;marray[0][1]=0.;marray[0][2]=1.;
	marray[1][0]=0.;marray[1][1]=0.;marray[1][2]=-1.;

	// Spinodal parameters
	double a=0.3;
	double w=4.;
	double gamma0=1.;
	double beta=0.0;

	double ep = 0.03;
	double time =0.;
	double dt=0.0000004;
	double tmax=2;

	// Random initialization
	double sigma = 2.;
	const unsigned int nn =20000;
	double porosity = 0.5;

	for(unsigned int k=0; k < nz; k++) {
		for(unsigned int j=0;j<ny;j++){
			for(unsigned int i=0;i<nx;i++){
				phiGlobal[k*nx*ny+j*nx+i]=porosity;
			}
		}
	}

	double	sign = (rand()%2)*2.-1.;
	//Generate initial phi-Field using #nn Gaussians
	double mux,muy,muz; mux=0.;muy=0.,muz=0.;

	for (unsigned int g=0; g<nn;g++){
		mux=rand()% nx;
		muy=rand()% ny;
		muz=rand()% nz;
		sign = (rand()%2)*2.-1.;
		if ((mux>sigma && mux<(nx-sigma))&&(muy>sigma && muy<(ny-sigma))&&(muz>sigma && muz<(nz-sigma))){

#pragma omp parallel for
			for(unsigned int k=0; k < nx; k++) {
				for(unsigned int j=0;j<ny;j++){
					for(unsigned int i=0;i<nz;i++){
						phiGlobal[k*nx*ny+j*nx+i]+=1.*sign*exp(-(0.5*pow((i-mux)/sigma,2) + 0.5*pow((j-muy)/sigma,2)+ 0.5*pow((k-muz)/sigma,2)))/pow(0.5*nn,0.5);
					}
				}
			}
		}
	}

	int timestep =0;
	outputFile_tot.open(filename_tot,std::ofstream::app);
	outputFile_tot <<"Energy," <<"Mobility,"  << "time," << endl;
	outputFile_tot.close();

	while(time<tmax){
		timestep+=1;

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			Fphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (phiGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]],0.);
		}

		Forward3.fft(Fphi);

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Flphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])=Fphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])*(Wk(0)*Wk(0)+Wk(1)*Wk(1)+Wk(2)*Wk(2));

		}

		Backward3.fftNormalized(Flphi);

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			lphiGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]=Flphi(mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
		};

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Fgradphi[0](mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(0);
			Fgradphi[1](mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(1);
			Fgradphi[2](mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fphi(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(2);
		};



		for(int dim=0; dim<3; dim++){
			Backward3.fftNormalized(Fgradphi[dim]);
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				gradPhiGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim]=Fgradphi[dim](mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
			}
		};

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			gammaGlobal[MI]=gamma0;
			for (unsigned int o = 0; o < numberofm; o++){
				Displacements mo;
				mo[0]=marray[o][0];
				mo[1]=marray[o][1];
				mo[2]=marray[o][2];
				Displacements nlocal;
				if(pow(gradPhiGlobal[MI][0]*gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]*gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]*gradPhiGlobal[MI][2],0.5) > 1.e-16){
				nlocal[0]=gradPhiGlobal[MI][0]/pow(gradPhiGlobal[MI][0]*gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]*gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]*gradPhiGlobal[MI][2],0.5);
				nlocal[1]=gradPhiGlobal[MI][1]/pow(gradPhiGlobal[MI][0]*gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]*gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]*gradPhiGlobal[MI][2],0.5);
				nlocal[2]=gradPhiGlobal[MI][2]/pow(gradPhiGlobal[MI][0]*gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]*gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]*gradPhiGlobal[MI][2],0.5);
					if (nlocal[0]*mo[0]+nlocal[1]*mo[1]+nlocal[2]*mo[2]>0.){
					gammaGlobal[MI]-=gamma0*a*pow((nlocal[0]*mo[0]+nlocal[1]*mo[1]+nlocal[2]*mo[2]),w);

					}
					}
				else {
					gammaGlobal[MI]-=gamma0*a*pow((0.*mo[0]+0.*mo[1]+0.*mo[2]),w);
				}
			}
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			uGlobal[MI][0]=gammaGlobal[MI]*gradPhiGlobal[MI][0];
			uGlobal[MI][1]=gammaGlobal[MI]*gradPhiGlobal[MI][1];
			uGlobal[MI][2]=gammaGlobal[MI]*gradPhiGlobal[MI][2];
		}

		for(unsigned int dim=0; dim < 3; dim++) {
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				Fu[dim](mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (uGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim],0.);
			}
			Forward3.fft(Fu[dim]);
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Fr(mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fu[0](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(0)+Fu[1](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(1)+Fu[2](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(2);
		}

		Backward3.fftNormalized(Fr);
#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			rGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]=Fr(mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			double dxx=(gradPhiGlobal[MI][0]*gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]*gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]*gradPhiGlobal[MI][2]);
			qGlobal[MI][0]=0.;	qGlobal[MI][1]=0.; qGlobal[MI][2]=0.;
			if( pow(dxx,0.5) > 1.e-16){
			Displacements normal;
			normal[0] = gradPhiGlobal[MI][0] / pow(dxx,0.5);
			normal[1] = gradPhiGlobal[MI][1] / pow(dxx,0.5);
			normal[2] = gradPhiGlobal[MI][2] / pow(dxx,0.5);
			for (unsigned int o = 0; o < numberofm; o++){
				Displacements mo;
				mo[0]=marray[o][0];
				mo[1]=marray[o][1];
				mo[2]=marray[o][2];
				double ndm = mo[0]*normal[0]+mo[1]*normal[1]+mo[2]*normal[2];
				if (ndm>0.){
					qGlobal[MI][0]+= pow(dxx,0.5)*(1.-normal[0]*normal[0])*(-gamma0*w*a*mo[0]*pow(ndm,w-1.))+pow(dxx,0.5)*(-normal[0]*normal[1])*(-gamma0*w*a*mo[1]*pow(ndm,w-1.))+pow(dxx,0.5)*(-normal[0]*normal[2])*(-gamma0*w*a*mo[2]*pow(ndm,w-1.));
					qGlobal[MI][1]+= pow(dxx,0.5)*(-normal[1]*normal[0])*(-gamma0*w*a*mo[0]*pow(ndm,w-1.))+pow(dxx,0.5)*(1.-normal[1]*normal[1])*(-gamma0*w*a*mo[1]*pow(ndm,w-1.))+pow(dxx,0.5)*(-normal[1]*normal[2])*(-gamma0*w*a*mo[2]*pow(ndm,w-1.));
					qGlobal[MI][2]+= pow(dxx,0.5)*(-normal[2]*normal[0])*(-gamma0*w*a*mo[0]*pow(ndm,w-1.))+pow(dxx,0.5)*(-normal[2]*normal[1])*(-gamma0*w*a*mo[1]*pow(ndm,w-1.))+pow(dxx,0.5)*(1.-normal[2]*normal[2])*(-gamma0*w*a*mo[2]*pow(ndm,w-1.));
				}

			}
}
		}

		for(unsigned int dim=0; dim < 3; dim++) {
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				Fq[dim](mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (qGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim],0.);
			}
			Forward3.fft(Fq[dim]);
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Fp(mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fq[0](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(0)+Fq[1](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(1)+Fq[2](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(2);
		}

		Backward3.fftNormalized(Fp);
#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			pGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]=Fp(mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			kappaGlobal[MI]=-ep*lphiGlobal[MI]+(1./ep)*computeBp(phiGlobal[MI]);
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			Fkappa(mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (kappaGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]],0.);

		}

		Forward3.fft(Fkappa);

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Flkappa(mapper[MI][0],mapper[MI][1],mapper[MI][2])=Fkappa(mapper[MI][0],mapper[MI][1],mapper[MI][2])*(Wk(0)*Wk(0)+Wk(1)*Wk(1)+Wk(2)*Wk(2));
		}

		Backward3.fftNormalized(Flkappa);

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			lkappaGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]=Flkappa(mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			muGlobal[MI]=1./ep*(gammaGlobal[MI]*computeBp(phiGlobal[MI])-ep*ep*(rGlobal[MI]+pGlobal[MI]))+beta*(1./(ep*ep) * computeBpp(phiGlobal[MI])*kappaGlobal[MI]-lkappaGlobal[MI]);
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			Fmu(mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (muGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]],0.);
		}

		Forward3.fft(Fmu);
#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			Fgradmu[0](mapper[MI][0],mapper[MI][1],mapper[MI][2])=Fmu(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(0);
			Fgradmu[1](mapper[MI][0],mapper[MI][1],mapper[MI][2])=Fmu(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(1);
			Fgradmu[2](mapper[MI][0],mapper[MI][1],mapper[MI][2])=Fmu(mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(2);
		}

		for(int dim=0; dim<3; dim++){
			Backward3.fftNormalized(Fgradmu[dim]);
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				gradmuGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim]=Fgradmu[dim](mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();

			}
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				gradmuGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim]*= pow(64.*computeB(phiGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]),0.5);
			}

		};


		for(unsigned int dim=0; dim < 3; dim++) {
#pragma omp parallel for
			for(unsigned int MI=0; MI< nx*ny*nz; MI++){
				Fgradmu[dim](mapper[MI][0],mapper[MI][1],mapper[MI][2])=complex<double> (gradmuGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]][dim],0.);
			}
			Forward3.fft(Fgradmu[dim]);
		}

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			FourierWave Wk,Wkl;
			Wk.Allocate(3,align);
			Wk(0)=Kvec2x[mapper[MI][0]];
			Wk(1)=Kvec2y[mapper[MI][1]];
			Wk(2)=Kvec2z[mapper[MI][2]];
			FdivM(mapper[MI][0],mapper[MI][1],mapper[MI][2]) = Fgradmu[0](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(0)+Fgradmu[1](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(1)+Fgradmu[2](mapper[MI][0],mapper[MI][1],mapper[MI][2])*Wk(2);
		}

		Backward3.fftNormalized(FdivM);

#pragma omp parallel for
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			divMGlobal[mapper[MI][2]*nx*ny+mapper[MI][1]*nx+mapper[MI][0]]=FdivM(mapper[MI][0],mapper[MI][1],mapper[MI][2]).real();
		}

		double mobility_tot=0.;
		double energy_tot=0.;
#pragma omp parallel for reduction( + : mobility_tot,energy_tot)
		for(unsigned int MI=0; MI< nx*ny*nz; MI++){
			mobility_tot+=fabs(divMGlobal[MI]);
			energy_tot+=ep/2.*  (gradPhiGlobal[MI][0]* gradPhiGlobal[MI][0]+gradPhiGlobal[MI][1]* gradPhiGlobal[MI][1]+gradPhiGlobal[MI][2]* gradPhiGlobal[MI][2])+1./ep * computeB(phiGlobal[MI]);
		}

		cout <<"dt is" << dt << "	mobility is: 	"<< mobility_tot<< "	energy is:	"<<energy_tot<< endl;


#pragma omp parallel for
		for(unsigned int MI=0; MI < nx*ny*nz; MI++) {
			if (timestep<200) {


				phiGlobal[MI]+=(dt)/ep*(divMGlobal[MI]);
			}
			else {



				phiGlobal[MI]+=(dt)/ep*(divMGlobal[MI]);
			}

		};

		cout << timestep << endl;
		if(timestep%500 == 0 || timestep == 1 ){
		//	cout << "Anisotropy factor is " << 2*CAVG(5,5)/(CAVG(0,0)-CAVG(0,1)) <<endl;
filename[16] =  (int)((timestep%1000000)/100000) + '0';  filename[17] = (int)((timestep%100000)/10000) + '0';
				filename[18] = (int)((timestep%10000)/1000) + '0';  filename[19] =  (int)((timestep%1000)/100) + '0';
				filename[20] = (int)((timestep%100)/10) + '0';  filename[21] = (int)((timestep%10)/1) + '0';
				filename[23]= (int)(5) + '0';
				puts(filename);
				ofstream outputFile;
				outputFile.open(filename);
			       	//outputFile << "Node,"<< "Phi,"<< "X," << "Y," << "Z,"  << "gamma," <<"DivM,"  <<"Sig_11,"  <<"Sig_22,"  <<"Sig_33,"  <<"Sig_23,"  <<"Sig_13,"  <<"Sig_12," << "time," << endl;
//outputFile << "Node,"<< "Phi,"<< "X," << "Y," << "Z," << "time," << endl;
outputFile <<  "X," << "Y," << "Z," <<"Phi,"<<  endl;

			int x_it = 0;
			int y_it = 0;
			int z_it = 0;
			for(unsigned int k=0; k < nz+1; k++) {
				for(unsigned int j=0; j < ny+1; j++){
					for(unsigned int i=0; i < nx+1; i++){
				//	outputFile << 1+MI << "," << phiGlobal[MI] << "," << delx*mapper[MI][0] << "," <<  dely*mapper[MI][1] << "," << delz*mapper[MI][2] << "," << gammaGlobal[MI]<< "," <<  divMGlobal[MI]<<","  << tau[MI](0,0) <<","  << tau[MI](1,1) <<","  << tau[MI](2,2) <<","  << tau[MI](1,2) <<","  << tau[MI](0,2) <<","  << tau[MI](0,1) <<","<< time  << endl;
				if(k==nz){z_it = 0;}
				else{z_it = k;}
				if(j==ny){y_it = 0;}
				else{y_it = j;}
				if(i==nx){x_it = 0;}
				else{x_it = i;}
				outputFile << delx*i << "," <<  dely*j << "," << delz*k<< "," <<phiGlobal[z_it*nx*ny+y_it*nx+x_it] << endl;

				}
				}
			}
				outputFile.close();
			}

		outputFile_tot.open(filename_tot,std::ofstream::app);
		outputFile_tot << energy_tot << "," << mobility_tot << "," << time <<endl;
		outputFile_tot.close();


		time+=dt;
	}
	return 0;
}
